﻿namespace EffectLibrary
{
    using System;
    using System.Windows;
    using System.Windows.Media;
    using System.Windows.Media.Effects;

    /// <summary>
    /// 
    /// </summary>
    public class MaskColorEffect : ShaderEffect
    {
        /// <summary>
        /// 
        /// </summary>
        public static readonly DependencyProperty InputProperty =
            ShaderEffect.RegisterPixelShaderSamplerProperty("Input", typeof(MaskColorEffect), 0);

        /// <summary>
        /// 
        /// </summary>
        public static readonly DependencyProperty ColorProperty =
            DependencyProperty.Register("Color", typeof(Color), typeof(MaskColorEffect), new UIPropertyMetadata(Colors.Transparent, PixelShaderConstantCallback(0)));

        /// <summary>
        /// 
        /// </summary>
        public MaskColorEffect()
        {
            PixelShader = new PixelShader()
            {
                UriSource = new Uri("/EffectLibrary;component/MaskColorShader.ps", UriKind.RelativeOrAbsolute)
            };

            UpdateShaderValue(InputProperty);
            UpdateShaderValue(ColorProperty);
        }

        /// <summary>
        /// 
        /// </summary>
        public Brush Input
        {
            get { return GetValue(InputProperty) as Brush; }
            set { SetValue(InputProperty, value); }
        }

        /// <summary>
        /// 
        /// </summary>
        public Color Color
        {
            get { return (Color)GetValue(ColorProperty); }
            set { SetValue(ColorProperty, value); }
        }
    }
}
